/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            frame.h
 *
 *  Mon Nov 15 19:45:07 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __FRAME_H__
#define __FRAME_H__

// Definition of vector
#include <vector>

class Frame {
public:
  Frame(unsigned char *d, int sz);
  ~Frame();
  
  unsigned char *data;
  unsigned int size;

  unsigned int number;

  unsigned int bitrate;

  bool shoot;
  int freeze; // 1 is freeze, -1 is unfreeze
  bool record;
  char timecode[12];

  bool endOfFrameStream;
};

typedef std::vector< Frame* > FrameVector;

#endif/*__FRAME_H__*/
