/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            iso11172-2.h
 *
 *  Tue Sep  6 13:31:04 CEST 2005
 *  Copyright  2005 Bent Bisballe Nyeng
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_ISO11172_2_H__
#define __MIAV_ISO11172_2_H__

namespace ISO11172_2 {
  ////////////////////////////////////////////////////
  // Types
  ////////////////////////////////////////////////////
  typedef struct {
    unsigned long int picture_rate:4;
    unsigned long int pel_aspect_ratio:4;
    unsigned long int vertical_size:12;
    unsigned long int horizontal_size:12;
  } sequence_header_1;

  typedef struct {
    unsigned long int load_non_intra_quantizer_flag:1;
    unsigned long int load_intra_quantizer_flag:1;
    unsigned long int constrained_parameter_flag:1;
    unsigned long int vbv_buffer_size:10;
    unsigned long int marker_bit:1;
    unsigned long int bitrate:18;
  } sequence_header_2;

  ////////////////////////////////////////////////////
  // Constants
  ////////////////////////////////////////////////////
  const char picture_start_code[] = "\x00\x00\x01\x00";
  const char slice_start_code_prefix[] ="\x00\x00\x01";
  //  const char _code = "\x00\x00\x01\xB0"; //Reserved
  //  const char _code = "\x00\x00\x01\xB1"; //Reserved
  const char user_data_start_code[] = "\x00\x00\x01\xB2";
  const char sequence_header_code[] = "\x00\x00\x01\xB3";
  const char sequence_error_code[] = "\x00\x00\x01\xB4";
  const char sequence_start_code[] = "\x00\x00\x01\xB5";
  //  const char _code = "\x00\x00\x01\xB6"; //Reserved
  const char sequence_end_code[] = "\x00\x00\x01\xB7";
  const char group_start_code[] = "\x00\x00\x01\xB8";
  const char system_start_code_prefix[] = "\x00\x00\x01";

  ////////////////////////////////////////////////////
  // Methods
  ////////////////////////////////////////////////////
  
};

#endif/*__MIAV_ISO11172_2_H__*/
