/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            libfame_wrapper.h
 *
 *  Sat Jul  2 11:11:31 CEST 2005
 *  Copyright  2005 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_LIBFAME_WRAPPER_H__
#define __MIAV_LIBFAME_WRAPPER_H__

// Use libfame
#include <fame.h>

// Use libdv
#include <libdv/dv.h>
#include <libdv/dv_types.h>

#include "frame.h"
#include "info.h"

// size specifies the length of the buffer. 
#define FAME_BUFFER_SIZE	(1024*1024)	// FIXME: One size fits all...

class LibFAMEWrapper {
public:
  LibFAMEWrapper(Info *info);
  ~LibFAMEWrapper();

  Frame *encode(Frame *dvframe);

private:
  unsigned long long calc_bitrate;
  unsigned int frame_number;

  Info* info;

  // libFAME encoder
  //  unsigned char *fame_buffer;
  fame_parameters_t fame_par;
  fame_context_t *fame_context;
  fame_yuv_t yuv;
  unsigned char fame_buffer[FAME_BUFFER_SIZE];

  // libdv decoder
 	dv_decoder_t *dvdecoder;

  unsigned char picture[FAME_BUFFER_SIZE];
};

#endif/*__MIAV_LIBFAME_WRAPPER_H__*/
