/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            package.h
 *
 *  Tue Nov  9 10:57:20 CET 2004
 *  Copyright  2004 Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAVLIB_PACKAGE_H__
#define __MIAVLIB_PACKAGE_H__

typedef enum {
  NO_CHANGE = 0,
  SAVE,
  DELETE,
  LATER
} n_savestate;

typedef enum {
  DATA_HEADER = 0x0001,
  INFO_HEADER = 0x0002
} n_header_type;

typedef struct {
  n_header_type header_type;
  union {
    struct {
      char cpr[32]; // Can hold wierd cpr numbers as well (not only danish)
      bool record;
      bool freeze;
      bool snapshot;
      n_savestate savestate;
    } h_data;
    struct {
      int fisk; 
    } h_info;
  } header;
} n_header;


#endif/*__PACKAGE_H__*/


