/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            threadsafe_queue.h
 *
 *  Tue Sep 27 14:01:01 CEST 2005
 *  Copyright  2005 Bent Bisballe Nyeng
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifndef __MIAV_THREADSAFE_QUEUE_H__
#define __MIAV_THREADSAFE_QUEUE_H__

#include "mutex.h"
#include "semaphore.h"

template <typename T>
class ThreadSafeQueue {
public:
  ThreadSafeQueue() {
    //    pthread_mutex_init (&mutex, NULL);
    //    sem_init(&semaphore, 0, 0);
  }

  virtual ~ThreadSafeQueue() {
    //    pthread_mutex_destroy(&mutex);
    //sem_destroy(&semaphore);
  }

  virtual void push(T t) = 0;
  virtual T pop() = 0;
  virtual int size() = 0;

protected:
  //  pthread_mutex_t mutex;
  Mutex mutex;
  //sem_t semaphore;
  Semaphore semaphore;
};

#endif/*__MIAV_THREADSAFE_QUEUE_H__*/
