/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            videowidget.h
 *
 *  Fri Sep  3 14:36:46 2004
 *  Copyright  2004  Bent Bisballe
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *    This file is part of MIaV.
 *
 *    MIaV is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MIaV is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MIaV; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifdef USE_GUI
 
#ifndef __VIDEOWIDGET_H__
#define __VIDEOWIDGET_H__

#include <qwidget.h>
#include <qpixmap.h>

#include "camera.h"

class VideoWidget : public QWidget {
Q_OBJECT
public:
  VideoWidget(QWidget *parent, Camera *camera, QWidget *old = NULL);
  ~VideoWidget();
  QPixmap getScreenshot();
  void mouseReleaseEvent(QMouseEvent *event);

private:
  Camera *camera;

  QWidget *parent;

  // Reassign SDL to this when closing (if non-NULL)
  QWidget *oldWindow;
};

#endif /* __VIDEOWIDGET_H__ */

#endif /* USE_GUI */
