/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/***************************************************************************
 *            yuv_draw.h
 *
 *  Thu Sep 22 12:35:28 CEST 2005
 *  Copyright  2005 Bent Bisballe Nyeng
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of MIaV.
 *
 *  MIaV is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MIaV is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MIaV; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#include "config.h"
#ifdef USE_GUI
#ifndef __MIAV_YUV_DRAW_H__
#define __MIAV_YUV_DRAW_H__

#include <SDL/SDL.h>

#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>

class YUVDraw {
public:
  YUVDraw();
  ~YUVDraw();

  void setOverlay(SDL_Overlay* overlay);

  void addPixel(int x, int y, int val);

  void setTopText(char* text);
  void setBottomText(char* text);

  void draw();

private:
  SDL_Overlay* overlay;

  QPixmap *top_pixmap;
  unsigned char top_grey[720][20];

  QPixmap *bottom_pixmap;
  unsigned char bottom_grey[720][20];
};

#endif/*__MIAV_YUV_DRAW_H__*/
#endif/*USE_GUI*/
